#include <math.h>
#include <iostream>
#include <conio.h>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include "histogram_internal.h"
#include <curl/curl.h>
#include <sstream>
#include <string>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
    size_t interval;
};

Input
input_data(istream &tin, bool prompt){
    if (prompt)
        cerr << "Input numbers count: ";
    size_t number_count;
    tin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    if (prompt)
        cerr << "Input numbers: ";
    for (size_t i = 0; i < number_count; i++) {
        tin >> in.numbers[i];
    }
    if (prompt)
        cerr << "Input bin count: ";
    tin >> in.bin_count;
    return in;
}

size_t write_data(void* items, size_t item_size, size_t item_count, void* ctx) {
    size_t data_size = item_size * item_count;
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    buffer->write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}
Input
download(const string& address)
{
    stringstream buffer;
    CURL *curl = curl_easy_init();
    if(curl)
    {
        CURLcode res;
        curl_off_t speed;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);

        if (res != CURLE_OK)
        {
            fprintf(stderr, "curl_easy_perform() failed: %s\n",curl_easy_strerror(res));
            exit(1);
        }
        res = curl_easy_getinfo(curl, CURLINFO_SPEED_DOWNLOAD_T, &speed);
        if(!res)
        {
            cerr<<"Download speed bytes/sec:  " <<speed;
        }

        curl_easy_cleanup(curl);

    }
    return input_data(buffer, false);
}
int
main(int argc, char* argv[]) {
    Input input;
    if (argc > 1) {
        input = download(argv[1]);
    } else {
        input = input_data(cin, true);
    }
    const auto bins = make_histogram(input.numbers, input.bin_count);
    show_histogram_svg(bins);
}
